=== debian/changelog ===
ovito (0.9.2-1) unstable; urgency=low

  * Initial release (Closes: #600812)

 -- Pekko Metsä <pjmetsa@gmail.com>  Sun, 31 Oct 2010 00:44:04 +0300
