=== debian/control ===
Source: ovito
Section: science
Priority: extra
Maintainer: Pekko Metsä <pjmetsa@gmail.com>
Build-Depends: debhelper (>= 7.0.50), cmake, libboost-dev, libboost-iostreams-dev, libboost-python-dev, libqt4-opengl-dev, qt4-dev-tools, libgsl0-dev, xsltproc, docbook-xml, docbook-xsl, docbook-xsl-doc-html, libqscintilla2-dev, python-dev, libmuparser-dev
Standards-Version: 3.9.1
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Recommends: ovito-doc, ovito-examples
Suggests: povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ovito, ovito-examples
Section: doc
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.

Package: ovito-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: ovito, ovito-doc
Section: doc
Description: tutorial examples for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the tutorial examples for ovito.
